import AppHeader from "@/components/AppHeader";
import BorderBottomItem from "@/components/borderBottomItem";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import ButtonSelect from "@/components/buttonSelect";
import DrawerBottom from "@/components/drawerBottom";
import { InputForm } from "@/components/inputForm";
import LoadingCenter from "@/components/loadingCenter";
import MenuItemRow from "@/components/menuItemRow";
import ModalSelectMultiple from "@/components/modalSelectMultiple";
import Text from "@/components/Text";
import Styles from "@/constants/Styles";
import { setUpdateAnnouncement } from "@/lib/announcementUpdate";
import { apiCreateAnnouncement } from "@/lib/api";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { Entypo, Ionicons, MaterialCommunityIcons } from "@expo/vector-icons";
import * as DocumentPicker from "expo-document-picker";
import { router, Stack } from "expo-router";
import React, { useEffect, useState } from "react";
import { SafeAreaView, ScrollView, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

export default function CreateAnnouncement() {
   const dispatch = useDispatch()
   const update = useSelector((state: any) => state.announcementUpdate)
   const { token, decryptToken } = useAuthSession()
   const { colors } = useTheme();
   const [disableBtn, setDisableBtn] = useState(true);
   const [modalDivisi, setModalDivisi] = useState(false);
   const [divisionMember, setDivisionMember] = useState<any>([])
   const [loading, setLoading] = useState(false)
   const [fileForm, setFileForm] = useState<any[]>([])
   const [isModalFile, setModalFile] = useState(false)
   const [indexDelFile, setIndexDelFile] = useState<number>(0)
   const [dataForm, setDataForm] = useState({
      title: "",
      desc: "",
   });
   const [error, setError] = useState({
      title: false,
      desc: false,
   });

   function validationForm(cat: string, val: any) {
      if (cat == "title") {
         setDataForm({ ...dataForm, title: val });
         if (val == "" || val == "null") {
            setError({ ...error, title: true });
         } else {
            setError({ ...error, title: false });
         }
      } else if (cat == "desc") {
         setDataForm({ ...dataForm, desc: val });
         if (val == "" || val == "null") {
            setError({ ...error, desc: true });
         } else {
            setError({ ...error, desc: false });
         }
      }
   }

   function checkForm() {
      if (
         Object.values(error).some((v) => v == true) ||
         Object.values(dataForm).some((v) => v == "")
      ) {
         setDisableBtn(true);
      } else {
         setDisableBtn(false);
      }
   }

   useEffect(() => {
      checkForm();
   }, [error, dataForm]);

   async function handleCreate() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current))
         const fd = new FormData()

         for (let i = 0; i < fileForm.length; i++) {
            fd.append(`file${i}`, {
               uri: fileForm[i].uri,
               type: 'application/octet-stream',
               name: fileForm[i].name,
            } as any);
         }

         fd.append("data", JSON.stringify(
            { user: hasil, groups: divisionMember, ...dataForm }
         ))

         const response = await apiCreateAnnouncement(fd)

         if (response.success) {
            dispatch(setUpdateAnnouncement(!update))
            Toast.show({ type: 'small', text1: 'Berhasil menambahkan data', })
            router.back();
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error: any) {
         console.error(error);
         const message = error?.response?.data?.message || "Tidak dapat terhubung ke server"

         Toast.show({
            type: 'small',
            text1: message
         })
      } finally {
         setLoading(false)
      }
   }

   const pickDocumentAsync = async () => {
      let result = await DocumentPicker.getDocumentAsync({
         type: ["*/*"],
         multiple: true
      });
      if (!result.canceled) {
         for (let i = 0; i < result.assets?.length; i++) {
            if (result.assets[i].uri) {
               setFileForm((prev) => [...prev, result.assets[i]])
            }
         }
      }
   };

   function deleteFile(index: number) {
      setFileForm([...fileForm.filter((val, i) => i !== index)])
      setModalFile(false)
   }

   return (
      <SafeAreaView style={[Styles.flex1, { backgroundColor: colors.background }]}>
         <Stack.Screen
            options={{
               // headerLeft: () => (
               //    <ButtonBackHeader
               //       onPress={() => {
               //          router.back();
               //       }}
               //    />
               // ),
               headerTitle: "Tambah Pengumuman",
               headerTitleAlign: "center",
               // headerRight: () => (
               //    <ButtonSaveHeader
               //       disable={disableBtn || divisionMember.length == 0 || loading ? true : false}
               //       category="create"
               //       onPress={() => {
               //          divisionMember.length == 0
               //             ? Toast.show({ type: 'small', text1: "Anda belum memilih divisi", })
               //             : handleCreate();
               //       }}
               //    />
               // ),
               header: () => (
                  <AppHeader
                     title="Tambah Pengumuman"
                     showBack={true}
                     onPressLeft={() => router.back()}
                     right={
                        <ButtonSaveHeader
                           disable={disableBtn || divisionMember.length == 0 || loading ? true : false}
                           category="create"
                           onPress={() => {
                              divisionMember.length == 0
                                 ? Toast.show({ type: 'small', text1: "Anda belum memilih divisi", })
                                 : handleCreate();
                           }}
                        />
                     }
                  />
               )
            }}
         />
         {loading && <LoadingCenter />}
         <ScrollView
            showsVerticalScrollIndicator={false}
            style={[Styles.h100, { backgroundColor: colors.background }]}
         >
            <View style={[Styles.p15]}>
               <InputForm
                  label="Judul"
                  type="default"
                  placeholder="Judul Pengumuman"
                  required
                  error={error.title}
                  bg={colors.card}
                  errorText="Judul harus diisi"
                  onChange={(val) => validationForm("title", val)}
               />
               <InputForm
                  label="Pengumuman"
                  type="default"
                  placeholder="Deskripsi Pengumuman"
                  required
                  error={error.desc}
                  bg={colors.card}
                  errorText="Pengumuman harus diisi"
                  onChange={(val) => validationForm("desc", val)}
                  multiline
               />
               <ButtonSelect value="Upload File" onPress={pickDocumentAsync} />
               {
                  fileForm.length > 0
                  &&
                  <>
                     <View style={[Styles.rowSpaceBetween, Styles.mv05]}>
                        <Text style={[Styles.textDefaultSemiBold]}>File</Text>
                        <Text style={[Styles.textDefault]}>{fileForm.length} file</Text>
                     </View>
                     <View style={[Styles.borderAll, Styles.round05, Styles.p10, Styles.mb10, { backgroundColor: colors.card, borderColor: colors.icon + '20' }]}>
                        {
                           fileForm.map((item, index) => (
                              <BorderBottomItem
                                 key={index}
                                 borderType={fileForm.length - 1 == index ? "none" : "bottom"}
                                 icon={<MaterialCommunityIcons name="file-outline" size={25} color={colors.text} />}
                                 title={item.name}
                                 bgColor="transparent"
                                 titleWeight="normal"
                                 onPress={() => { setIndexDelFile(index); setModalFile(true) }}
                              />
                           ))
                        }
                     </View>
                  </>
               }

               <ButtonSelect
                  value="Pilih divisi penerima pengumuman"
                  onPress={() => {
                     setModalDivisi(true)
                  }}
               />

               {
                  divisionMember.length > 0
                  &&
                  <>
                     <View style={[Styles.rowSpaceBetween, Styles.mv05]}>
                        <Text style={[Styles.textDefaultSemiBold]}>Divisi</Text>
                     </View>
                     <View style={[Styles.borderAll, Styles.round05, Styles.p10, { backgroundColor: colors.card, borderColor: colors.icon + '20' }]}>
                        {
                           divisionMember.map((item: { name: any; Division: any }, index: any) => {
                              return (
                                 <View key={index}>
                                    <Text style={[Styles.textDefaultSemiBold]}>{item.name}</Text>
                                    {
                                       item.Division.map((division: any, i: any) => (
                                          <View key={i} style={[Styles.rowItemsCenter, Styles.w90]}>
                                             <Entypo name="dot-single" size={24} color={colors.text} />
                                             <Text style={[Styles.textDefault]} numberOfLines={1} ellipsizeMode='tail'>{division.name}</Text>
                                          </View>
                                       ))
                                    }
                                 </View>
                              )
                           })
                        }
                     </View>
                  </>
               }
            </View>
         </ScrollView>

         <ModalSelectMultiple
            choose="dinas"
            title="Pilih Divisi"
            category="choose-division"
            open={modalDivisi}
            close={setModalDivisi}
            onSelect={(val) => {
               setDivisionMember(val)
               setModalDivisi(false)
            }}
         />

         <DrawerBottom animation="slide" isVisible={isModalFile} setVisible={setModalFile} title="Menu">
            <View style={Styles.rowItemsCenter}>
               <MenuItemRow
                  icon={<Ionicons name="trash-outline" color={colors.text} size={25} />}
                  title="Hapus"
                  onPress={() => { deleteFile(indexDelFile) }}
               />
            </View>
         </DrawerBottom>
      </SafeAreaView>
   );
}


